Option Strict On
Option Explicit On
Public Class Form1 ' Public Class AcessibilityHook
    Const WINEVENT_32BITCALLER As Int32 = &H8000
    Const WINEVENT_INCONTEXT As Int32 = &H4
    Const WINEVENT_OUTOFCONTEXT As Int32 = &H0
    Const WINEVENT_SKIPOWNPROCESS As Int32 = &H2
    Const WINEVENT_SKIPOWNTHREAD As Int32 = &H1
    Const WINEVENT_VALID As Int32 = &H8007
    Const EVENT_MIN As Int32 = 1
    Const EVENT_MAX As Int32 = &H7FFFFFFF
    Const SYS_SOUND As Int32 = 1
    Const SYS_ALERT As Short = 2
    Const SYS_FOREGROUND As Int32 = 3 'active window changing.
    Const SYS_MENUSTART As Int32 = 4  '--entering menu mode.
    Const SYS_MENUEND As Int32 = 5  '--leaving menu mode.
    Const SYS_MENUPOPUPSTART As Int32 = 6 '--popup menu popping up.
    Const SYS_MENUPOPUPEND As Int32 = 7 'popup menu about to close.
    Const SYS_CAPTURESTART As Int32 = 8  '--window took capture.
    Const SYS_CAPTUREEND As Int32 = 9   '--window released capture.
    Const SYS_MOVESIZESTART As Int32 = &HA '-- beginning move or resize.
    Const SYS_MOVESIZEEND As Int32 = &HB  '--ending move or resize.
    Const SYS_CONTEXTHELPSTART As Int32 = &HC
    Const SYS_CONTEXTHELPEND As Int32 = &HD
    Const SYS_DRAGDROPSTART As Int32 = &HE
    Const SYS_DRAGDROPEND As Int32 = &HF
    Const SYS_DIALOGSTART As Int32 = &H10  '--dialogue opens.
    Const SYS_DIALOGEND As Int32 = &H11  '--dialogue about to close.
    Const SYS_SCROLLINGSTART As Int32 = &H12  '--scrolling.
    Const SYS_SCROLLINGEND As Int32 = &H13
    Const SYS_SWITCHSTART As Int32 = &H14  ' Sent when beginning and ending alt-tab mode with the switch window.
    Const SYS_SWITCHEND As Int32 = &H15
    Const SYS_MINIMIZESTART As Int32 = &H16     '--window minimizing.
    Const SYS_MINIMIZEEND As Int32 = &H17    '--window about to restore.
    Const OB_CREATE As Int32 = &H8000  '-- hwnd + ID + idChild is created item
    Const OB_DESTROY As Int32 = &H8001  '-- hwnd + ID + idChild is destroyed item
    Const OB_SHOW As Int32 = &H8002  '-- hwnd + ID + idChild is shown item
    Const OB_HIDE As Int32 = &H8003  '-- hwnd + ID + idChild is hidden item
    Const OB_REORDER As Int32 = &H8004  '-- hwnd + ID + idChild is parent of zordering children
    Const OB_FOCUS As Int32 = &H8005   '--  hwnd + ID + idChild is focused item
    Const OB_SELECTION As Int32 = &H8006 '-- hwnd + ID + idChild is selected item (if only one), or idChild is OBJID_WINDOW if complex
    Const OB_SELECTIONADD As Int32 = &H8007 '-- hwnd + ID + idChild is item added
    Const OB_SELECTIONREMOVE As Int32 = &H8008 '-- hwnd + ID + idChild is item removed
    Const OB_SELECTIONWITHIN As Int32 = &H8009 '-- hwnd + ID + idChild is parent of changed selected
    Const OB_STATECHANGE As Int32 = &H800A ' hwnd + ID + idChild is item w/ state change
    Const OB_LOCATIONCHANGE As Int32 = &H800B  '-- hwnd + ID + idChild is moved/sized item
    Const OB_NAMECHANGE As Int32 = &H800C  '-- hwnd + ID + idChild is item w/ name change
    Const OB_DESCRIPTIONCHANGE As Int32 = &H800D  '-- hwnd + ID + idChild is item w/ desc change
    Const OB_VALUECHANGE As Int32 = &H800E  '-- hwnd + ID + idChild is item w/ value change
    Const OB_PARENTCHANGE As Int32 = &H800F  '-- hwnd + ID + idChild is item w/ new parent
    Const OB_HELPCHANGE As Int32 = &H8010  '-- hwnd + ID + idChild is item w/ help change
    Const OB_DEFACTIONCHANGE As Int32 = &H8011  '-- hwnd + ID + idChild is item w/ def action change
    Const OB_ACCELERATORCHANGE As Int32 = &H8012 '  hwnd + ID + idChild is item w/ keybd accel change
    Private Declare Function apiSetWinEventHook Lib "user32" Alias "SetWinEventHook" (ByVal eventMin As Int32, ByVal eventMax As Int32, ByVal hmodWinEventProc As Int32, ByVal pfnWinEventProc As EventFunc, ByVal idProcess As Int32, ByVal idThread As Int32, ByVal dwFlags As Int32) As Int32
    Private Declare Function apiUnhookWinEvent Lib "user32" Alias "UnhookWinEvent" (ByVal lHandle As Int32) As Int32
    Private Declare Function apiAccessibleObjectFromEvent Lib "oleacc" Alias "AccessibleObjectFromEvent" (ByVal hwnd As Int32, ByVal dwId As Int32, ByVal dwChildId As Int32, ByRef ppacc As Global.Accessibility.IAccessible, ByRef pvarChild As Object) As Int32
    Private Delegate Function EventFunc(ByVal HookHandle As Int32, ByVal LEvent As Int32, ByVal hwnd As Int32, ByVal idObject As Int32, ByVal idChild As Int32, ByVal idEventThread As Int32, ByVal dwmsEventTime As Int32) As Int32
    Private eHook As Int32
    <System.Runtime.InteropServices.MarshalAs(System.Runtime.InteropServices.UnmanagedType.FunctionPtr)> Private mEventFunc As EventFunc

    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        HookEvents()
    End Sub

    Private Sub Form1_FormClosed(ByVal sender As Object, ByVal e As System.Windows.Forms.FormClosedEventArgs) Handles Me.FormClosed
        UnHookEvents()
    End Sub

    Public Sub HookEvents()
        If eHook <> 0 Then Exit Sub
        mEventFunc = New EventFunc(AddressOf WinEventFunc)
        eHook = apiSetWinEventHook(SYS_FOREGROUND, SYS_FOREGROUND, 0, mEventFunc, 0, 0, WINEVENT_SKIPOWNPROCESS)
    End Sub

    Public Sub UnHookEvents()
        If eHook <> 0 Then apiUnhookWinEvent(eHook)
    End Sub

    Private Function WinEventFunc(ByVal eHandle As Int32, ByVal lEvent As Int32, ByVal hWnd As Int32, ByVal objId As Int32, ByVal childId As Int32, ByVal eThreadId As Int32, ByVal eTime As Int32) As Int32
        Dim acc As Global.Accessibility.IAccessible = Nothing
        Dim cId As Object = Nothing
        Dim sName As String = ""
        apiAccessibleObjectFromEvent(hWnd, objId, childId, acc, cId)
        If Not acc Is Nothing Then
            If Not cId Is Nothing Then
                Try
                    sName = acc.accName(cId)
                    Me.Text = sName
                Catch ex As System.Runtime.InteropServices.COMException When ex.ErrorCode = -2146827864 'weird 
                Catch ex As System.Runtime.InteropServices.COMException When ex.ErrorCode = -2147467259  'null
                Catch ex As System.Runtime.InteropServices.COMException When ex.ErrorCode = -2147417848  'rpc disconnected
                Catch ex As ArgumentException 'null
                Catch ex As NullReferenceException
                End Try
            End If
        End If
        WinEventFunc = 0
    End Function


End Class
